
clear;
clc;

load mtl_demo.mat
% the data contains the estimated WTP distribution parameters for 2 programs in 9 countries
% we are treating the distributions as if they were normal here (demonstration purposes only)

% find MTL for each possible transfer of the WTP for each program

% TOSZ test: 

EQ1min_tosz = zeros(9,9);
EQ2min_tosz = zeros(9,9);

for i = 1:9
    for j = 1:9        
        if i == j
            EQ1min_tosz(i,j) = 0;
            EQ2min_tosz(i,j) = 0;
        else
            EQ1min_tosz(i,j) = MTL([B1(i),B1(j)],diag([S1(i),S1(j)].^2));
            EQ2min_tosz(i,j) = MTL([B2(i),B2(j)],diag([S2(i),S2(j)].^2));
        end
    end
end

% TOSC test:

EQ1min_tosc = zeros(9,9);
EQ2min_tosc = zeros(9,9);

for i = 1:9
    for j = 1:9        
        if i == j
            EQ1min_tosc(i,j) = 0;            
            EQ2min_tosc(i,j) = 0;
        else
            EQ1min_tosc(i,j) = MTL([B1(i),B1(j)],diag([S1(i),S1(j)].^2),EQ1min_tosz(i,j),1,1e4,1e-4);
            EQ2min_tosc(i,j) = MTL([B2(i),B2(j)],diag([S2(i),S2(j)].^2),EQ2min_tosz(i,j),1,1e4,1e-4);
        end
    end
end

% compare the results of the two approaches

dEQ1 = EQ1min_tosc - EQ1min_tosz
dEQ2 = EQ2min_tosc - EQ2min_tosz
